
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _gps_led_counter=R5
	.DEF _step_led=R4
	.DEF _now_h=R7
	.DEF _now_m=R6
	.DEF _now_s=R9
	.DEF _utc=R8
	.DEF _sync_gps=R10
	.DEF _sync_gps_msb=R11
	.DEF _sync_successfull=R13
	.DEF _dp_counter=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP _usart_rx_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0008

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0

_0x1B2:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0
_0x0:
	.DB  0x47,0x50,0x52,0x4D,0x43,0x0,0x25,0x69
	.DB  0x3A,0x25,0x30,0x32,0x64,0x3A,0x25,0x30
	.DB  0x32,0x64,0x3A,0x20,0x0,0x2D,0x2D,0x3A
	.DB  0x2D,0x2D,0x3A,0x2D,0x2D,0x3A,0x20,0x0
	.DB  0x53,0x41,0x54,0x45,0x4C,0x4C,0x49,0x54
	.DB  0x45,0x53,0x20,0x53,0x55,0x43,0x43,0x45
	.DB  0x53,0x53,0x46,0x55,0x4C,0x4C,0x59,0x20
	.DB  0x46,0x4F,0x55,0x4E,0x44,0x3A,0x20,0x0
	.DB  0x4E,0x4F,0x20,0x41,0x56,0x41,0x49,0x4C
	.DB  0x41,0x42,0x4C,0x45,0x20,0x53,0x41,0x54
	.DB  0x45,0x4C,0x4C,0x49,0x54,0x45,0x53,0x3A
	.DB  0x20,0x0,0x25,0x73,0xD,0xA,0x0,0x53
	.DB  0x59,0x4E,0x43,0x20,0x43,0x4F,0x4D,0x50
	.DB  0x4C,0x45,0x54,0x45,0x44,0xD,0xA,0x0
	.DB  0x43,0x55,0x52,0x52,0x45,0x4E,0x54,0x20
	.DB  0x53,0x54,0x4F,0x50,0x57,0x41,0x54,0x43
	.DB  0x48,0x3A,0x20,0x25,0x69,0x3A,0x25,0x30
	.DB  0x32,0x64,0x3A,0x25,0x30,0x32,0x64,0xD
	.DB  0xA,0x0,0x53,0x54,0x41,0x52,0x54,0x20
	.DB  0x43,0x4C,0x4F,0x43,0x4B,0xD,0xA,0x0
	.DB  0x43,0x55,0x52,0x52,0x45,0x4E,0x54,0x20
	.DB  0x54,0x49,0x4D,0x45,0x3A,0x20,0x25,0x69
	.DB  0x3A,0x25,0x30,0x32,0x64,0x3A,0x25,0x30
	.DB  0x32,0x64,0x2C,0x20,0x54,0x49,0x4D,0x45
	.DB  0x20,0x5A,0x4F,0x4E,0x45,0x3A,0x20,0x0
	.DB  0x2B,0x0,0x25,0x69,0x2C,0x20,0x0,0x41
	.DB  0x4C,0x41,0x52,0x4D,0x20,0x53,0x54,0x41
	.DB  0x54,0x55,0x53,0x3A,0x20,0x25,0x69,0x3A
	.DB  0x25,0x30,0x32,0x64,0x0,0x41,0x4C,0x41
	.DB  0x52,0x4D,0x20,0x53,0x54,0x41,0x54,0x55
	.DB  0x53,0x3A,0x20,0x4F,0x46,0x46,0x0
_0x2040060:
	.DB  0x1
_0x2040000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x0A
	.DW  0x04
	.DW  __REG_VARS*2

	.DW  0x01
	.DW  __seed_G102
	.DW  _0x2040060*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*******************************************************
;Project : GPS  " 401-"
;Version : 1.0
;Date    : 17.05.2017
;Author  : Vitaly S. Anisimov
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*******************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;#include <string.h>
;#include <stdlib.h>
;
;#include <Lib\define.c>
;//  
;//         
;#define L_BUS_ON        1
;
;//          
;#define L_BUS_OFF       0
;
;//        
;#define L_S_ON          0
;
;//         
;#define L_S_OFF         1
;
;//     
;#define S_A      PORTD.4
;#define S_B      PORTD.2
;#define S_C      PORTC.2
;#define S_D      PORTC.4
;#define S_E      PORTC.5
;#define S_F      PORTD.3
;#define S_G      PORTC.1
;
;#define D_P      PORTC.3
;
;#define S_1      PORTD.5
;#define S_2      PORTD.6
;#define S_3      PORTD.7
;#define S_4      PORTC.0
;
;//    GPS 
;#define GPS      PORTB.2
;
;//   GPS 
;#define GPS_LED  PORTB.1
;
;//    
;#define H_BUT    PINB.3
;
;//    
;#define M_BUT    PINB.4
;
;//    
;#define UTC_BUT  PINB.5
;
;//  
;#define BUZZER   PORTB.0
;
;//    
;#define BUZZER_ON   1
;
;//     
;#define BUZZER_OFF  0
;
;// -    
;#define DAY      86400
;
;//    
;#define GPS_ON   0
;
;//    
;#define GPS_OFF  1
;
;//    (   )
;#define PAUSE_SYNC  3600
;
;// -  ,   ,    
;#define SYNC_SUCCESS    5
;
;//       
;#define DP_SHOW     50
;
;
;//    
;unsigned char gps_led_counter = 0;
;
;//   gps
;bit gps_status = 0;
;
;//  
;unsigned char step_led = 0;
;
;//     
;unsigned char segment[ 4 ] = { 0 };
;
;//   
;unsigned long int utc_counter = 0;
;
;//  
;unsigned long int stopwatch_counter = 0;
;
;//   
;signed char now_h = 0;
;
;//   
;unsigned char now_m = 0;
;
;//   
;unsigned char now_s = 0;
;
;//     1 /
;bit timer_1s = 0;
;
;//    
;signed char utc = 0;
;
;// -     
;unsigned int sync_gps = 0;
;
;// -  -   
;unsigned char sync_successfull = 0;
;
;//  ,      
;bit main_exe = 0;
;
;//      DP
;bit dp = L_S_OFF;
;
;//     DP
;unsigned char dp_counter = 0;
;
;//   
;bit buzzer_active = 0;
;
;//  / 
;bit alarm = 0;
;
;//        
;bit alarm_pause = 0;
;
;//  
;unsigned char buzzer_counter = 0;
;
;//  
;unsigned char alarm_h = 0;
;
;//  
;unsigned char alarm_m = 0;
;
;
;//***********************eeprom ********************//
;
;//    
;unsigned char eeprom first_start;
;
;//      
;signed char eeprom eeprom_utc;
;
;//      eeprom
;unsigned char eeprom eeprom_alarm_h;
;
;//      eeprom
;unsigned char eeprom eeprom_alarm_m;
;
;//      /    eeprom
;unsigned char eeprom eeprom_alarm;
;
;
;
;#include <Lib\uart.c>
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<DOR)
;
;// USART Receiver buffer
;#define RX_BUFFER_SIZE 256
;
;//  
;unsigned char rx_buffer[ RX_BUFFER_SIZE ];
;
;//    
;unsigned char rx_wr_index = 0;
;
;//    ""  
;bit rx_buffer_complete = 0;
;
;//    UART
;void rx_clear( void ) {
; 0000 0017 void rx_clear( void ) {

	.CSEG
_rx_clear:
; .FSTART _rx_clear
;
;	rx_wr_index = 0;
	LDI  R30,LOW(0)
	STS  _rx_wr_index,R30
;	rx_buffer_complete = 0;
	CLT
	BLD  R2,7
;	rx_buffer[ 0 ] = 0;
	STS  _rx_buffer,R30
;
;//   
;return;
	RET
;}
; .FEND
;
;//      
;unsigned char answer_contains( char flash * s ) {
_answer_contains:
; .FSTART _answer_contains
;	if ( strstrf( rx_buffer, s ) == 0 ) return 0;
	ST   -Y,R27
	ST   -Y,R26
;	*s -> Y+0
	LDI  R30,LOW(_rx_buffer)
	LDI  R31,HIGH(_rx_buffer)
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _strstrf
	SBIW R30,0
	BRNE _0x3
	LDI  R30,LOW(0)
	RJMP _0x20A0006
;
;//       0,    1,   
;return 1;
_0x3:
	LDI  R30,LOW(1)
	RJMP _0x20A0006
;}
; .FEND
;
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void) {
_usart_rx_isr:
; .FSTART _usart_rx_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;char status, data;
;status = UCSRA;
	RCALL __SAVELOCR2
;	status -> R17
;	data -> R16
	IN   R17,11
;data = UDR;
	IN   R16,12
;
;    //      
;    //           
;    if ( rx_buffer_complete ) return;
	SBRC R2,7
	RJMP _0x268
;
;    if ( status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN) ) return;
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x268
;
;    //   0x0A,     0x0D
;    if ( data == 0x0A ) return;
	CPI  R16,10
	BREQ _0x268
;
;    	//  0x0D -  
;    	if ( data == 0x0D ) {
	CPI  R16,13
	BRNE _0x7
;
;        //    GPRMC-   , ..    
;        if ( !answer_contains( "GPRMC" ) ) {
	__POINTW2FN _0x0,0
	RCALL _answer_contains
	CPI  R30,0
	BRNE _0x8
;
;        //   
;        rx_clear();
	RCALL _rx_clear
;
;        // 
;        return;
	RJMP _0x268
;        }
;
;    //  ,    
;    rx_buffer_complete = 1;
_0x8:
	SET
	BLD  R2,7
;
;    //   
;    return;
	RJMP _0x268
;	}
;    //    
;    else {
_0x7:
;
;	//   
;	rx_buffer[ rx_wr_index ] = data;
	LDS  R30,_rx_wr_index
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
;
;	//   0   
;	rx_buffer[ rx_wr_index + 1 ] = 0;
	LDS  R30,_rx_wr_index
	LDI  R31,0
	__ADDW1MN _rx_buffer,1
	LDI  R26,LOW(0)
	STD  Z+0,R26
;
;	//     
;	rx_wr_index++;
	LDS  R30,_rx_wr_index
	SUBI R30,-LOW(1)
	STS  _rx_wr_index,R30
;
;	//  
;	if ( rx_wr_index > ( RX_BUFFER_SIZE - 2 ) ) rx_wr_index = RX_BUFFER_SIZE - 2;
	LDS  R26,_rx_wr_index
	CPI  R26,LOW(0xFF)
	BRLO _0xA
	LDI  R30,LOW(254)
	STS  _rx_wr_index,R30
;
;    // 
;    return;
_0xA:
;	}
;
;}
_0x268:
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;
;#include <Lib\led.c>
;
;//    
;void case_char( unsigned char x_chars ) {
; 0000 0019 void case_char( unsigned char x_chars ) {
_case_char:
; .FSTART _case_char
;
;        switch ( x_chars ) {
	ST   -Y,R26
;	x_chars -> Y+0
	LD   R30,Y
	LDI  R31,0
;        //0
;        case 0: S_A = L_S_ON; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_ON; S_E = L_S_ON; S_F = L_S_ON; S_G = L_S_OFF;  brea ...
	SBIW R30,0
	BRNE _0xE
	CBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	CBI  0x15,4
	CBI  0x15,5
	CBI  0x12,3
	RJMP _0x259
;        //1
;        case 1: S_A = L_S_OFF; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_OFF; b ...
_0xE:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x1D
	SBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	RJMP _0x25A
;        //2
;        case 2: S_A = L_S_ON; S_B = L_S_ON; S_C = L_S_OFF; S_D = L_S_ON; S_E = L_S_ON; S_F = L_S_OFF; S_G = L_S_ON; brea ...
_0x1D:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2C
	CBI  0x12,4
	CBI  0x12,2
	SBI  0x15,2
	CBI  0x15,4
	CBI  0x15,5
	SBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //3
;        case 3: S_A = L_S_ON; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_ON; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_ON; brea ...
_0x2C:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x3B
	CBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	CBI  0x15,4
	SBI  0x15,5
	SBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //4
;        case 4: S_A = L_S_OFF; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_ON; S_G = L_S_ON; bre ...
_0x3B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x4A
	SBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	SBI  0x15,4
	SBI  0x15,5
	CBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //5
;        case 5: S_A = L_S_ON; S_B = L_S_OFF; S_C = L_S_ON; S_D = L_S_ON; S_E = L_S_OFF; S_F = L_S_ON; S_G = L_S_ON; brea ...
_0x4A:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x59
	CBI  0x12,4
	SBI  0x12,2
	CBI  0x15,2
	CBI  0x15,4
	SBI  0x15,5
	CBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //6
;        case 6: S_A = L_S_ON; S_B = L_S_OFF; S_C = L_S_ON; S_D = L_S_ON; S_E = L_S_ON; S_F = L_S_ON; S_G = L_S_ON; break ...
_0x59:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x68
	CBI  0x12,4
	SBI  0x12,2
	CBI  0x15,2
	CBI  0x15,4
	CBI  0x15,5
	CBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //7
;        case 7: S_A = L_S_ON; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_OFF; br ...
_0x68:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x77
	CBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	RJMP _0x25A
;        //8
;        case 8: S_A = L_S_ON; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_ON; S_E = L_S_ON; S_F = L_S_ON; S_G = L_S_ON; break;
_0x77:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x86
	CBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	CBI  0x15,4
	CBI  0x15,5
	CBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //9
;        case 9: S_A = L_S_ON; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_ON; S_E = L_S_OFF; S_F = L_S_ON; S_G = L_S_ON; break ...
_0x86:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x95
	CBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	CBI  0x15,4
	SBI  0x15,5
	CBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        // -
;        case 10: S_A = L_S_OFF; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_ON; ...
_0x95:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0xA4
	SBI  0x12,4
	SBI  0x12,2
	SBI  0x15,2
	SBI  0x15,4
	SBI  0x15,5
	SBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        // B
;        case 11: S_A = L_S_OFF; S_B = L_S_ON; S_C = L_S_OFF; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_OFF; ...
_0xA4:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0xB3
	SBI  0x12,4
	CBI  0x12,2
	RJMP _0x25B
;        // C
;        case 12: S_A = L_S_OFF; S_B = L_S_OFF; S_C = L_S_ON; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_OFF; ...
_0xB3:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0xC2
	SBI  0x12,4
	SBI  0x12,2
	CBI  0x15,2
	RJMP _0x25A
;        // D
;        case 13: S_A = L_S_OFF; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_ON; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_OFF; ...
_0xC2:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0xD1
	SBI  0x12,4
	SBI  0x12,2
	SBI  0x15,2
	CBI  0x15,4
	RJMP _0x25C
;        // E
;        case 14: S_A = L_S_OFF; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_OFF; S_E = L_S_ON; S_F = L_S_OFF; S_G = L_S_OFF; ...
_0xD1:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0xE0
	SBI  0x12,4
	SBI  0x12,2
	SBI  0x15,2
	SBI  0x15,4
	CBI  0x15,5
	RJMP _0x25D
;        // F
;        case 15: S_A = L_S_OFF; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_ON; S_G = L_S_OFF; ...
_0xE0:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0xEF
	SBI  0x12,4
	SBI  0x12,2
	SBI  0x15,2
	SBI  0x15,4
	SBI  0x15,5
	CBI  0x12,3
	RJMP _0x259
;        // G
;        case 16: S_A = L_S_ON; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_OFF; ...
_0xEF:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0xFE
	CBI  0x12,4
	RJMP _0x25E
;        // U
;        case 17: S_A = L_S_OFF; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_ON; S_E = L_S_ON; S_F = L_S_ON; S_G = L_S_OFF; bre ...
_0xFE:
	CPI  R30,LOW(0x11)
	LDI  R26,HIGH(0x11)
	CPC  R31,R26
	BRNE _0x10D
	SBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	CBI  0x15,4
	CBI  0x15,5
	CBI  0x12,3
	RJMP _0x259
;        // A
;        case 18: S_A = L_S_ON; S_B = L_S_ON; S_C = L_S_ON; S_D = L_S_OFF; S_E = L_S_ON; S_F = L_S_ON; S_G = L_S_ON; brea ...
_0x10D:
	CPI  R30,LOW(0x12)
	LDI  R26,HIGH(0x12)
	CPC  R31,R26
	BRNE _0x11C
	CBI  0x12,4
	CBI  0x12,2
	CBI  0x15,2
	SBI  0x15,4
	CBI  0x15,5
	CBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //  
;        case 19: S_A = L_S_ON; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_ON; S_E = L_S_ON; S_F = L_S_ON; S_G = L_S_OFF;  b ...
_0x11C:
	CPI  R30,LOW(0x13)
	LDI  R26,HIGH(0x13)
	CPC  R31,R26
	BRNE _0x12B
	CBI  0x12,4
	SBI  0x12,2
	SBI  0x15,2
	CBI  0x15,4
	CBI  0x15,5
	CBI  0x12,3
	RJMP _0x259
;        //  F
;        case 20: S_A = L_S_ON; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_OFF; S_E = L_S_ON; S_F = L_S_ON; S_G = L_S_ON;  b ...
_0x12B:
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BRNE _0x149
	CBI  0x12,4
	SBI  0x12,2
	SBI  0x15,2
	SBI  0x15,4
	CBI  0x15,5
	CBI  0x12,3
	CBI  0x15,1
	RJMP _0xD
;        //  ( )
;        default: S_A = L_S_OFF; S_B = L_S_OFF; S_C = L_S_OFF; S_D = L_S_OFF; S_E = L_S_OFF; S_F = L_S_OFF; S_G = L_S_OFF ...
_0x149:
	SBI  0x12,4
_0x25E:
	SBI  0x12,2
_0x25B:
	SBI  0x15,2
_0x25A:
	SBI  0x15,4
_0x25C:
	SBI  0x15,5
_0x25D:
	SBI  0x12,3
_0x259:
	SBI  0x15,1
;        }
_0xD:
;}
	RJMP _0x20A0001
; .FEND
;
;    //    ""
;    void refresh_segment( unsigned char i ) {
_refresh_segment:
; .FSTART _refresh_segment
;
;    //   
;    #define     DELAY_S     60
;
;    //  
;    unsigned char j;
;
;        switch ( i ) {
	ST   -Y,R26
	ST   -Y,R17
;	i -> Y+1
;	j -> R17
	LDD  R30,Y+1
	LDI  R31,0
;
;        //     
;        case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x15B
;
;            //   11  16  
;            for ( j = 11; j < 17; j++ ) {
	LDI  R17,LOW(11)
_0x15D:
	CPI  R17,17
	BRSH _0x15E
;            //         
;            segment[ 0 ] = segment[ 1 ] = j;
	__POINTW2MN _segment,1
	MOV  R30,R17
	ST   X,R30
	STS  _segment,R30
;            //    
;            delay_ms( DELAY_S );
	LDI  R26,LOW(60)
	LDI  R27,0
	RCALL _delay_ms
;            }
	SUBI R17,-1
	RJMP _0x15D
_0x15E:
;            //    
;            segment[ 0 ] = segment[ 1 ] = 99;
	LDI  R30,LOW(99)
	RJMP _0x25F
;            //    ,     
;            delay_ms( DELAY_S / 6 );
;
;        break;
;
;        //     
;        case 2:
_0x15B:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x163
;
;            //   11  16  
;            for ( j = 11; j < 17; j++ ) {
	LDI  R17,LOW(11)
_0x161:
	CPI  R17,17
	BRSH _0x162
;            //         
;            segment[ 2 ] = segment[ 3 ] = j;
	__POINTW2MN _segment,3
	MOV  R30,R17
	ST   X,R30
	__PUTB1MN _segment,2
;            //    
;            delay_ms( DELAY_S );
	LDI  R26,LOW(60)
	LDI  R27,0
	RCALL _delay_ms
;            }
	SUBI R17,-1
	RJMP _0x161
_0x162:
;            //    
;            segment[ 2 ] = segment[ 3 ] = 99;
	LDI  R30,LOW(99)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
;            //    ,     
;            delay_ms( DELAY_S / 6 );
	RJMP _0x260
;
;        break;
;
;        //   
;        default:
_0x163:
;
;            //   11  16  
;            for ( j = 11; j < 17; j++ ) {
	LDI  R17,LOW(11)
_0x165:
	CPI  R17,17
	BRSH _0x166
;            //       
;            segment[ 0 ] = segment[ 1 ]  = segment[ 2 ] = segment[ 3 ] = j;
	__POINTW2MN _segment,3
	MOV  R30,R17
	ST   X,R30
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
	STS  _segment,R30
;            //    
;            delay_ms( DELAY_S );
	LDI  R26,LOW(60)
	LDI  R27,0
	RCALL _delay_ms
;            }
	SUBI R17,-1
	RJMP _0x165
_0x166:
;            //     
;            segment[ 0 ] = segment[ 1 ]  = segment[ 2 ] = segment[ 3 ] = 99;
	LDI  R30,LOW(99)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
_0x25F:
	__PUTB1MN _segment,1
	STS  _segment,R30
;            //    ,     
;            delay_ms( DELAY_S / 6 );
_0x260:
	LDI  R26,LOW(10)
	LDI  R27,0
	RCALL _delay_ms
;
;        break;
;        }
;
;    }
	LDD  R17,Y+0
	RJMP _0x20A0006
; .FEND
;
;    //     
;    void check_refresh_segment( unsigned char _hour, unsigned char _min ) {
_check_refresh_segment:
; .FSTART _check_refresh_segment
;
;        //       
;        if ( ( segment[ 1 ] != _hour % 10 ) && ( segment[ 3 ] != _min % 10 ) ) {
	ST   -Y,R26
;	_hour -> Y+1
;	_min -> Y+0
	LDD  R26,Y+1
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	__GETB2MN _segment,1
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x168
	LD   R26,Y
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	__GETB2MN _segment,3
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x169
_0x168:
	RJMP _0x167
_0x169:
;        //   
;        refresh_segment( 3 );
	LDI  R26,LOW(3)
	RCALL _refresh_segment
;        //    
;        return;
	RJMP _0x20A0006
;        }
;
;        //      
;        if ( segment[ 1 ] != _hour % 10 ) {
_0x167:
	LDD  R26,Y+1
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	__GETB2MN _segment,1
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x16A
;        //      
;        refresh_segment( 1 );
	LDI  R26,LOW(1)
	RCALL _refresh_segment
;        //    
;        return;
	RJMP _0x20A0006
;        }
;
;        //      
;        if ( segment[ 3 ] != _min % 10  ) {
_0x16A:
	LD   R26,Y
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	__GETB2MN _segment,3
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x16B
;        //     
;        refresh_segment( 2 );
	LDI  R26,LOW(2)
	RCALL _refresh_segment
;        //    
;        return;
;        }
;
;    }
_0x16B:
_0x20A0006:
	ADIW R28,2
	RET
; .FEND
;
;//       
;void refresh_led_time( void ) {
_refresh_led_time:
; .FSTART _refresh_led_time
;//   LED  
;//    0,  ""   
;
;//    
;check_refresh_segment(  now_h, now_m );
	ST   -Y,R7
	MOV  R26,R6
	RCALL _check_refresh_segment
;
;//       (.. >10)    ,      
;if ( ( now_h / 10 ) == 0 ) segment[ 0 ] = 99; else segment[ 0 ] = now_h / 10;
	MOV  R26,R7
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	SBIW R30,0
	BRNE _0x16C
	LDI  R30,LOW(99)
	RJMP _0x261
_0x16C:
	MOV  R26,R7
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
_0x261:
	STS  _segment,R30
;
;//   
;segment[ 1 ] = now_h % 10;
	MOV  R26,R7
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	__PUTB1MN _segment,1
;
;//   
;segment[ 2 ] = now_m / 10;
	MOV  R26,R6
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	__PUTB1MN _segment,2
;
;//   
;segment[ 3 ] = now_m % 10;
	MOV  R26,R6
	RJMP _0x20A0003
;}
; .FEND
;
;
;#include <Lib\timers.c>
;// Timer 0 ( 4,48 ms )
;// 
;interrupt [TIM0_OVF] void timer0_ovf_isr(void) {
; 0000 001B interrupt [10] void timer0_ovf_isr(void) {
_timer0_ovf_isr:
; .FSTART _timer0_ovf_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;
;// Reinitialize Timer 0 value
;TCNT0=0xBA;
	LDI  R30,LOW(186)
	OUT  0x32,R30
;
;//    
;S_1 = S_2 = S_3 = S_4 = L_BUS_OFF;
	CBI  0x15,0
	CBI  0x12,7
	CBI  0x12,6
	CBI  0x12,5
;
;//   
;D_P = L_S_OFF;
	SBI  0x15,3
;
;    switch ( step_led ) {
	MOV  R30,R4
	LDI  R31,0
;
;    //         1,    1 
;    case 1: case_char( segment[ 0 ] ); S_1 = L_BUS_ON; break;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x17B
	LDS  R26,_segment
	RCALL _case_char
	SBI  0x12,5
	RJMP _0x17A
;
;    //         2,    2    ...
;    case 2: case_char( segment[ 1 ] ); D_P = dp; S_2 = L_BUS_ON; break;
_0x17B:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x17E
	__GETB2MN _segment,1
	RCALL _case_char
	SBRC R2,3
	RJMP _0x17F
	CBI  0x15,3
	RJMP _0x180
_0x17F:
	SBI  0x15,3
_0x180:
	SBI  0x12,6
	RJMP _0x17A
;
;    //         3,    3 
;    case 3: case_char( segment[ 2 ] ); S_3 = L_BUS_ON; break;
_0x17E:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x183
	__GETB2MN _segment,2
	RCALL _case_char
	SBI  0x12,7
	RJMP _0x17A
;
;    //         4,    4     ...
;    case 4: case_char( segment[ 3 ] ); S_4 = L_BUS_ON; step_led = 0; break;
_0x183:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x189
	__GETB2MN _segment,3
	RCALL _case_char
	SBI  0x15,0
;
;    //      0
;    default: step_led = 0; break;
_0x189:
_0x262:
	CLR  R4
;    }
_0x17A:
;
;    //     
;    step_led++;
	INC  R4
;}
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;
;// Timer1 ( 1 s )
;interrupt [TIM1_OVF] void timer1_ovf_isr(void) {
_timer1_ovf_isr:
; .FSTART _timer1_ovf_isr
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;// Reinitialize Timer1 value
;TCNT1H=0xBDC >> 8;
	LDI  R30,LOW(11)
	OUT  0x2D,R30
;TCNT1L=0xBDC & 0xff;
	LDI  R30,LOW(220)
	OUT  0x2C,R30
;
;//     
;utc_counter++;
	LDI  R26,LOW(_utc_counter)
	LDI  R27,HIGH(_utc_counter)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
;
;//      
;if ( utc_counter >= DAY ) utc_counter = 0;
	LDS  R26,_utc_counter
	LDS  R27,_utc_counter+1
	LDS  R24,_utc_counter+2
	LDS  R25,_utc_counter+3
	__CPD2N 0x15180
	BRLO _0x18A
	LDI  R30,LOW(0)
	STS  _utc_counter,R30
	STS  _utc_counter+1,R30
	STS  _utc_counter+2,R30
	STS  _utc_counter+3,R30
;
;//    
;sync_gps++;
_0x18A:
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;
;//    ,     
;if ( sync_gps > PAUSE_SYNC ) sync_gps = PAUSE_SYNC;
	LDI  R30,LOW(3600)
	LDI  R31,HIGH(3600)
	CP   R30,R10
	CPC  R31,R11
	BRSH _0x18B
	MOVW R10,R30
;
;//    
;stopwatch_counter++;
_0x18B:
	LDI  R26,LOW(_stopwatch_counter)
	LDI  R27,HIGH(_stopwatch_counter)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
;
;//     
;if ( stopwatch_counter >= DAY ) stopwatch_counter = 0;
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__CPD2N 0x15180
	BRLO _0x18C
	LDI  R30,LOW(0)
	STS  _stopwatch_counter,R30
	STS  _stopwatch_counter+1,R30
	STS  _stopwatch_counter+2,R30
	STS  _stopwatch_counter+3,R30
;
;//   
;timer_1s = 1;
_0x18C:
	SET
	BLD  R2,1
;}
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
; .FEND
;
;// Timer2 ( 9,984 ms )
;interrupt [TIM2_OVF] void timer2_ovf_isr(void) {
_timer2_ovf_isr:
; .FSTART _timer2_ovf_isr
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;// Reinitialize Timer2 value
;TCNT2=0x64;
	LDI  R30,LOW(100)
	OUT  0x24,R30
;
;
;//  !!!!
;//     
;//utc_counter++;
;//      
;//if ( utc_counter > DAY ) utc_counter = 0;
;
;
;    //   GPS
;    //    GPS        
;    if ( !gps_status && GPS == GPS_ON ) {
	SBRC R2,0
	RJMP _0x18E
	SBIS 0x18,2
	RJMP _0x18F
_0x18E:
	RJMP _0x18D
_0x18F:
;    //      
;    gps_led_counter++;
	INC  R5
;
;        //       7 ( .. 7 * 9,984 = 69,888  )
;        if ( GPS_LED && gps_led_counter >= 7 ) {
	SBIS 0x18,1
	RJMP _0x191
	LDI  R30,LOW(7)
	CP   R5,R30
	BRSH _0x192
_0x191:
	RJMP _0x190
_0x192:
;        //  
;        GPS_LED = 0;
	CBI  0x18,1
;        //  
;        gps_led_counter = 0;
	CLR  R5
;        }
;
;        //        93 ( .. 93 * 9,984 = 928,512  )
;        if ( !GPS_LED && gps_led_counter >= 93 ) {
_0x190:
	SBIC 0x18,1
	RJMP _0x196
	LDI  R30,LOW(93)
	CP   R5,R30
	BRSH _0x197
_0x196:
	RJMP _0x195
_0x197:
;        //  
;        GPS_LED = 1;
	SBI  0x18,1
;        //  
;        gps_led_counter = 0;
	CLR  R5
;        }
;    }
_0x195:
;
;    //    GPS        -   
;    if ( gps_status && GPS == GPS_ON ) GPS_LED = 1;
_0x18D:
	SBRS R2,0
	RJMP _0x19B
	SBIS 0x18,2
	RJMP _0x19C
_0x19B:
	RJMP _0x19A
_0x19C:
	SBI  0x18,1
;
;    //    -   
;    if ( GPS == GPS_OFF ) GPS_LED = 0;
_0x19A:
	SBIC 0x18,2
	CBI  0x18,1
;
;    //     
;    if ( main_exe ) {
	SBRS R2,2
	RJMP _0x1A2
;    //    
;    dp_counter++;
	INC  R12
;
;        //  ,      
;        if ( dp_counter >= DP_SHOW) {
	LDI  R30,LOW(50)
	CP   R12,R30
	BRLO _0x1A3
;        //     
;        dp = ~dp;
	LDI  R30,LOW(8)
	EOR  R2,R30
;        //  
;        dp_counter = 0;
	CLR  R12
;        }
;    }
_0x1A3:
;
;    //      1,     
;    if ( buzzer_active ) {
_0x1A2:
	SBRS R2,4
	RJMP _0x1A4
;    //    
;    buzzer_counter++;
	LDS  R30,_buzzer_counter
	SUBI R30,-LOW(1)
	STS  _buzzer_counter,R30
;
;        //         (    )
;        if ( BUZZER && buzzer_counter >= 50 ) {
	SBIS 0x18,0
	RJMP _0x1A6
	LDS  R26,_buzzer_counter
	CPI  R26,LOW(0x32)
	BRSH _0x1A7
_0x1A6:
	RJMP _0x1A5
_0x1A7:
;        //     BUZZER_OFF
;        BUZZER = BUZZER_OFF;
	CBI  0x18,0
;        //  
;        buzzer_counter = 0;
	LDI  R30,LOW(0)
	STS  _buzzer_counter,R30
;        }
;
;        //         (     )
;        if ( !BUZZER && buzzer_counter >= 100 ) {
_0x1A5:
	SBIC 0x18,0
	RJMP _0x1AB
	LDS  R26,_buzzer_counter
	CPI  R26,LOW(0x64)
	BRSH _0x1AC
_0x1AB:
	RJMP _0x1AA
_0x1AC:
;        //     BUZZER_ON
;        BUZZER = BUZZER_ON;
	SBI  0x18,0
;        //  
;        buzzer_counter = 0;
	LDI  R30,LOW(0)
	STS  _buzzer_counter,R30
;        }
;    }
_0x1AA:
;    //      0,      
;    else {
	RJMP _0x1AF
_0x1A4:
;    //   
;    BUZZER = BUZZER_OFF;
	CBI  0x18,0
;    //    0
;    buzzer_counter = 0;
	LDI  R30,LOW(0)
	STS  _buzzer_counter,R30
;    }
_0x1AF:
;
;}
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
; .FEND
;
;#include <Lib\clock.c>
;//       
;
;
;//     
;unsigned char gps_parse_string( void ) {
; 0000 001D unsigned char gps_parse_string( void ) {
_gps_parse_string:
; .FSTART _gps_parse_string
;
;//       
;#define GPS_BUFFER_SIZE 8
;
;//          
;unsigned char gps_time[ GPS_BUFFER_SIZE ] = { 0 };
;
;//      
;unsigned char extract_time_buffer[ 3 ] = { 0 };
;
;//   
;unsigned char count_comma = 0;
;
;//  
;unsigned char pos = 0;
;
;//         
;unsigned char pos_t = 0;
;
;//     
;unsigned long int result = 0;
;
;
;//         25 ,    
;if ( !rx_buffer_complete || ( strlen( rx_buffer ) < 25 ) ) return 0;
	SBIW R28,15
	LDI  R24,15
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x1B2*2)
	LDI  R31,HIGH(_0x1B2*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR4
;	gps_time -> Y+11
;	extract_time_buffer -> Y+8
;	count_comma -> R17
;	pos -> R16
;	pos_t -> R19
;	result -> Y+4
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	SBRS R2,7
	RJMP _0x1B4
	LDI  R26,LOW(_rx_buffer)
	LDI  R27,HIGH(_rx_buffer)
	RCALL _strlen
	SBIW R30,25
	BRSH _0x1B3
_0x1B4:
	LDI  R30,LOW(0)
	RJMP _0x20A0005
;
;    //            "$GPRMC"
;    // $GPRMC,084056.00,A,5430.30076,N,03615.36031,E,0.723,,250517,,,A*7B
;    for ( pos_t = 0; pos_t < strlen( rx_buffer ); pos_t++ ) {
_0x1B3:
	LDI  R19,LOW(0)
_0x1B7:
	LDI  R26,LOW(_rx_buffer)
	LDI  R27,HIGH(_rx_buffer)
	RCALL _strlen
	MOV  R26,R19
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x1B8
;
;    //    "",      ""-   $GPRMC,  
;    // ""   ""
;    if ( rx_buffer[ pos_t ] == 'M' && rx_buffer[ pos_t + 1 ] == 'C' ) pos = pos_t;
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R26,Z
	CPI  R26,LOW(0x4D)
	BRNE _0x1BA
	MOV  R30,R19
	LDI  R31,0
	__ADDW1MN _rx_buffer,1
	LD   R26,Z
	CPI  R26,LOW(0x43)
	BREQ _0x1BB
_0x1BA:
	RJMP _0x1B9
_0x1BB:
	MOV  R16,R19
;    }
_0x1B9:
	SUBI R19,-1
	RJMP _0x1B7
_0x1B8:
;
;    //  
;    pos_t = 0;
	LDI  R19,LOW(0)
;
;    //      
;    while ( pos < strlen( rx_buffer ) ) {
_0x1BC:
	LDI  R26,LOW(_rx_buffer)
	LDI  R27,HIGH(_rx_buffer)
	RCALL _strlen
	MOV  R26,R16
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x1BE
;
;        //   
;        if ( rx_buffer[ pos ] == ',' ) {
	MOV  R30,R16
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R26,Z
	CPI  R26,LOW(0x2C)
	BRNE _0x1BF
;        //    1
;        count_comma++;
	SUBI R17,-1
;        //     ! 1-  ,  
;        if ( count_comma == 1 ) pos_t = pos + 1;
	CPI  R17,1
	BRNE _0x1C0
	MOV  R30,R16
	SUBI R30,-LOW(1)
	MOV  R19,R30
;        }
_0x1C0:
;
;        //   2 ,   
;        if ( count_comma >= 2 ) break;
_0x1BF:
	CPI  R17,2
	BRSH _0x1BE
;        //    1  
;        pos++;
	SUBI R16,-1
;    }
	RJMP _0x1BC
_0x1BE:
;
;    //    2-  ,    
;    if ( count_comma < 2 ) return 0;
	CPI  R17,2
	BRSH _0x1C2
	LDI  R30,LOW(0)
	RJMP _0x20A0005
;
;    //         -   
;    if ( rx_buffer[ pos_t ] == ',' ) return 0;
_0x1C2:
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R26,Z
	CPI  R26,LOW(0x2C)
	BRNE _0x1C3
	LDI  R30,LOW(0)
	RJMP _0x20A0005
;
;
;    //    X  c  pos_t    
;    //   
;    pos = 0;
_0x1C3:
	LDI  R16,LOW(0)
;
;    //      
;    while ( pos < GPS_BUFFER_SIZE - 1 ) {
_0x1C4:
	CPI  R16,7
	BRSH _0x1C6
;
;    //         
;    gps_time[ pos ] = rx_buffer[ pos_t + pos ];
	MOV  R30,R16
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,11
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R26,R19
	CLR  R27
	MOV  R30,R16
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R30,Z
	MOVW R26,R0
	ST   X,R30
;
;    //   ""  
;    gps_time[ pos + 1 ] = 0;
	MOV  R30,R16
	LDI  R31,0
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,11
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;
;    //     
;    pos++;
	SUBI R16,-1
;
;    //        -  
;    if ( rx_buffer[ pos_t + pos ] == ',' || rx_buffer[ pos_t + pos ] == '.' ) break;
	MOV  R26,R19
	CLR  R27
	MOV  R30,R16
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R26,Z
	CPI  R26,LOW(0x2C)
	BREQ _0x1C8
	CPI  R26,LOW(0x2E)
	BRNE _0x1C7
_0x1C8:
	RJMP _0x1C6
;    }
_0x1C7:
	RJMP _0x1C4
_0x1C6:
;
;    //     6-  ,   
;    if ( strlen( gps_time ) < 6 ) return 0;
	MOVW R26,R28
	ADIW R26,11
	RCALL _strlen
	SBIW R30,6
	BRSH _0x1CA
	LDI  R30,LOW(0)
	RJMP _0x20A0005
;
;    //        0,      
;    if ( atol( gps_time ) == 0 ) return 0;
_0x1CA:
	MOVW R26,R28
	ADIW R26,11
	RCALL _atol
	RCALL __CPD10
	BRNE _0x1CB
	LDI  R30,LOW(0)
	RJMP _0x20A0005
;
;    //   -     
;    //        
;    if ( sync_successfull < ( SYNC_SUCCESS - 1 ) ) return 1;
_0x1CB:
	LDI  R30,LOW(4)
	CP   R13,R30
	BRSH _0x1CC
	RJMP _0x20A0004
;
;    //   
;    //     UTC
;    utc_counter = 0;
_0x1CC:
	LDI  R30,LOW(0)
	STS  _utc_counter,R30
	STS  _utc_counter+1,R30
	STS  _utc_counter+2,R30
	STS  _utc_counter+3,R30
;
;    //      2,   3 - 0, 2, 4
;    for ( pos = 0; pos < 6; pos += 2 ) {
	LDI  R16,LOW(0)
_0x1CE:
	CPI  R16,6
	BRLO PC+2
	RJMP _0x1CF
;
;    //        gps_time   extract_time_buffer   
;    for ( pos_t = 0; pos_t < 2; pos_t++ ) extract_time_buffer[ pos_t ] = gps_time[ pos + pos_t ];
	LDI  R19,LOW(0)
_0x1D1:
	CPI  R19,2
	BRSH _0x1D2
	MOV  R30,R19
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,8
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R26,R16
	CLR  R27
	MOV  R30,R19
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R28
	ADIW R26,11
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R19,-1
	RJMP _0x1D1
_0x1D2:
	LDI  R30,LOW(0)
	STD  Y+10,R30
;
;    //          
;    result = atoi( extract_time_buffer );
	MOVW R26,R28
	ADIW R26,8
	RCALL _atoi
	RCALL __CWD1
	__PUTD1S 4
;
;    //      (..  ),    ""-    3600 
;    if ( pos == 0 ) result *= 3600;
	CPI  R16,0
	BRNE _0x1D3
	__GETD2N 0xE10
	RCALL __MULD12U
	__PUTD1S 4
;
;    //     ,    ""-    60 
;    if ( pos == 2 ) result *= 60;
_0x1D3:
	CPI  R16,2
	BRNE _0x1D4
	__GETD1S 4
	__GETD2N 0x3C
	RCALL __MULD12U
	__PUTD1S 4
;
;    //    UTC  
;    utc_counter += result;
_0x1D4:
	__GETD1S 4
	LDS  R26,_utc_counter
	LDS  R27,_utc_counter+1
	LDS  R24,_utc_counter+2
	LDS  R25,_utc_counter+3
	RCALL __ADDD12
	STS  _utc_counter,R30
	STS  _utc_counter+1,R31
	STS  _utc_counter+2,R22
	STS  _utc_counter+3,R23
;    }
	SUBI R16,-LOW(2)
	RJMP _0x1CE
_0x1CF:
;
;
;//   
;return 1;
_0x20A0004:
	LDI  R30,LOW(1)
_0x20A0005:
	RCALL __LOADLOCR4
	ADIW R28,19
	RET
;}
; .FEND
;
;
;//       
;void calculation_time( void ) {
_calculation_time:
; .FSTART _calculation_time
;
;//   ()
;now_h = utc_counter / 3600;
	LDS  R26,_utc_counter
	LDS  R27,_utc_counter+1
	LDS  R24,_utc_counter+2
	LDS  R25,_utc_counter+3
	__GETD1N 0xE10
	RCALL __DIVD21U
	MOV  R7,R30
;
;//   ()
;now_m = ( utc_counter % 3600 ) / 60;
	LDS  R26,_utc_counter
	LDS  R27,_utc_counter+1
	LDS  R24,_utc_counter+2
	LDS  R25,_utc_counter+3
	__GETD1N 0xE10
	RCALL __MODD21U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3C
	RCALL __DIVD21U
	MOV  R6,R30
;
;//  
;now_s = utc_counter % 60;
	LDS  R26,_utc_counter
	LDS  R27,_utc_counter+1
	LDS  R24,_utc_counter+2
	LDS  R25,_utc_counter+3
	__GETD1N 0x3C
	RCALL __MODD21U
	MOV  R9,R30
;
;//   
;now_h += utc;
	ADD  R7,R8
;
;//     24  (),    
;if ( now_h >= 24 ) now_h -= 24;
	LDI  R30,LOW(24)
	CP   R7,R30
	BRLT _0x1D5
	SUB  R7,R30
;
;//     0  (  ),    
;if ( now_h < 0 ) now_h += 24;
_0x1D5:
	LDI  R30,LOW(0)
	CP   R7,R30
	BRGE _0x1D6
	LDI  R30,LOW(24)
	ADD  R7,R30
;
;}
_0x1D6:
	RET
; .FEND
;
;
;//    
;unsigned char synchronization( void ) {
_synchronization:
; .FSTART _synchronization
;
;            //  GPS 
;            GPS = GPS_ON;
	CBI  0x18,2
;
;            //   
;            if ( rx_buffer_complete ) {
	SBRS R2,7
	RJMP _0x1D9
;
;                //     ,     ,  -      ...
;                if ( ( now_h + now_m + now_s ) != 0 ) printf( "%i:%02d:%02d: ", now_h, now_m, now_s ); else printf( "--: ...
	MOV  R26,R7
	LDI  R27,0
	SBRC R26,7
	SER  R27
	CLR  R30
	ADD  R26,R6
	ADC  R27,R30
	MOV  R30,R9
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	SBIW R30,0
	BREQ _0x1DA
	__POINTW1FN _0x0,6
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R7
	RCALL __CBD1
	RCALL __PUTPARD1
	MOV  R30,R6
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOV  R30,R9
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _printf
	ADIW R28,14
	RJMP _0x1DB
_0x1DA:
	__POINTW1FN _0x0,21
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
;
;                //    
;                if ( gps_parse_string() ) {
_0x1DB:
	RCALL _gps_parse_string
	CPI  R30,0
	BREQ _0x1DC
;                //    GPS    
;                gps_status = 1;
	SET
	BLD  R2,0
;                //      
;                sync_successfull++;
	INC  R13
;                //     
;                printf( "SATELLITES SUCCESSFULLY FOUND: " );
	__POINTW1FN _0x0,32
	RJMP _0x263
;                }
;                //        
;                else {
_0x1DC:
;                //    GPS     
;                gps_status = 0;
	CLT
	BLD  R2,0
;                //      
;                sync_successfull = 0;
	CLR  R13
;                //     
;                printf( "NO AVAILABLE SATELLITES: " );
	__POINTW1FN _0x0,64
_0x263:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
;                }
;
;            //         GPS 
;            printf( "%s\r\n", rx_buffer );
	__POINTW1FN _0x0,90
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_rx_buffer)
	LDI  R31,HIGH(_rx_buffer)
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
;
;            //   
;            rx_clear();
	RCALL _rx_clear
;            }
;
;            //  SYNC_SUCCESS     
;            if ( sync_successfull >= SYNC_SUCCESS ) {
_0x1D9:
	LDI  R30,LOW(5)
	CP   R13,R30
	BRLO _0x1DE
;            //  GPS 
;            GPS = GPS_OFF;
	SBI  0x18,2
;            //    GPS     
;            gps_status = 0;
	CLT
	BLD  R2,0
;            //   
;            sync_gps = 0;
	CLR  R10
	CLR  R11
;            //      
;            sync_successfull = 0;
	CLR  R13
;            //     ,     ,  -     
;            if ( ( now_h + now_m + now_s ) != 0 ) printf( "%i:%02d:%02d: ", now_h, now_m, now_s ); else printf( "--:--:- ...
	MOV  R26,R7
	LDI  R27,0
	SBRC R26,7
	SER  R27
	CLR  R30
	ADD  R26,R6
	ADC  R27,R30
	MOV  R30,R9
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	SBIW R30,0
	BREQ _0x1E1
	__POINTW1FN _0x0,6
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R7
	RCALL __CBD1
	RCALL __PUTPARD1
	MOV  R30,R6
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOV  R30,R9
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _printf
	ADIW R28,14
	RJMP _0x1E2
_0x1E1:
	__POINTW1FN _0x0,21
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
;            //       
;            printf( "SYNC COMPLETED\r\n" );
_0x1E2:
	__POINTW1FN _0x0,95
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
;            }
;            //   ,     SYNC_SUCCESS,    
;            else return 0;
	RJMP _0x1E3
_0x1DE:
	LDI  R30,LOW(0)
	RET
;
;//      
;return 1;
_0x1E3:
	LDI  R30,LOW(1)
	RET
;}
; .FEND
;
;
;//  
;void stopwatch( void ) {
_stopwatch:
; .FSTART _stopwatch
;
;        //        
;        stopwatch_counter = 0;
	LDI  R30,LOW(0)
	STS  _stopwatch_counter,R30
	STS  _stopwatch_counter+1,R30
	STS  _stopwatch_counter+2,R30
	STS  _stopwatch_counter+3,R30
;
;        //       .        
;        while( 1 ) {
_0x1E4:
;
;            //             
;            if ( !UTC_BUT || !H_BUT || !M_BUT ) {
	SBIS 0x16,5
	RJMP _0x1E8
	SBIS 0x16,3
	RJMP _0x1E8
	SBIC 0x16,4
	RJMP _0x1E7
_0x1E8:
;
;            //      
;            while( !UTC_BUT || !H_BUT || !M_BUT );
_0x1EA:
	SBIS 0x16,5
	RJMP _0x1ED
	SBIS 0x16,3
	RJMP _0x1ED
	SBIC 0x16,4
	RJMP _0x1EC
_0x1ED:
	RJMP _0x1EA
_0x1EC:
;
;            //   
;            delay_ms( 2000 );
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	RCALL _delay_ms
;
;            //    
;            return;
	RET
;            }
;
;            //    1   
;            if ( timer_1s ) {
_0x1E7:
	SBRS R2,1
	RJMP _0x1EF
;
;            //   
;            timer_1s = 0;
	CLT
	BLD  R2,1
;
;            //       - 
;            if ( stopwatch_counter >= ( DAY - 3 ) ) return;
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__CPD2N 0x1517D
	BRLO _0x1F0
	RET
;
;                //     
;                if ( stopwatch_counter < 3600 ) {
_0x1F0:
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__CPD2N 0xE10
	BRSH _0x1F1
;
;                //     
;                now_h = stopwatch_counter / 60;
	__GETD1N 0x3C
	RCALL __DIVD21U
	MOV  R7,R30
;
;                //     
;                now_m = stopwatch_counter % 60;
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__GETD1N 0x3C
	RCALL __MODD21U
	RJMP _0x264
;                }
;                //     
;                else {
_0x1F1:
;                //     
;                now_h = stopwatch_counter / 3600;
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__GETD1N 0xE10
	RCALL __DIVD21U
	MOV  R7,R30
;
;                //     
;                now_m = ( stopwatch_counter % 3600 ) / 60;
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__GETD1N 0xE10
	RCALL __MODD21U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3C
	RCALL __DIVD21U
_0x264:
	MOV  R6,R30
;                }
;
;            //    
;            refresh_led_time();
	RCALL _refresh_led_time
;
;            //      
;            printf( "CURRENT STOPWATCH: %i:%02d:%02d\r\n", stopwatch_counter / 3600, ( stopwatch_counter % 3600 ) / 60,  ...
	__POINTW1FN _0x0,112
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__GETD1N 0xE10
	RCALL __DIVD21U
	RCALL __PUTPARD1
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__GETD1N 0xE10
	RCALL __MODD21U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3C
	RCALL __DIVD21U
	RCALL __PUTPARD1
	LDS  R26,_stopwatch_counter
	LDS  R27,_stopwatch_counter+1
	LDS  R24,_stopwatch_counter+2
	LDS  R25,_stopwatch_counter+3
	__GETD1N 0x3C
	RCALL __MODD21U
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _printf
	ADIW R28,14
;            }
;
;
;        }
_0x1EF:
	RJMP _0x1E4
;}
; .FEND
;
;#include <Lib\alarm.c>
;/////////////////////////////////////////////
;
;//  
;void check_alarm( void ) {
; 0000 001F void check_alarm( void ) {
_check_alarm:
; .FSTART _check_alarm
;
;    //       
;    if ( alarm_h != now_h || alarm_m != now_m || !alarm  ) {
	MOV  R30,R7
	LDS  R26,_alarm_h
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x1F4
	LDS  R26,_alarm_m
	CP   R6,R26
	BRNE _0x1F4
	SBRC R2,5
	RJMP _0x1F3
_0x1F4:
;
;    //     
;    buzzer_active = 0;
	CLT
	BLD  R2,4
;
;    //    
;    alarm_pause = 0;
	BLD  R2,6
;
;    // 
;    return;
	RET
;    }
;
;    //          -  
;    if ( alarm_h == now_h && alarm_m == now_m && !alarm_pause ) buzzer_active = 1;
_0x1F3:
	MOV  R30,R7
	LDS  R26,_alarm_h
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x1F7
	LDS  R26,_alarm_m
	CP   R6,R26
	BRNE _0x1F7
	SBRS R2,6
	RJMP _0x1F8
_0x1F7:
	RJMP _0x1F6
_0x1F8:
	SET
	BLD  R2,4
;
;    //          
;    if ( !UTC_BUT || !H_BUT || !M_BUT ) {
_0x1F6:
	SBIS 0x16,5
	RJMP _0x1FA
	SBIS 0x16,3
	RJMP _0x1FA
	SBIC 0x16,4
	RJMP _0x1F9
_0x1FA:
;
;    //     ,      
;    alarm_pause = 1;
	SET
	BLD  R2,6
;
;    //     
;    buzzer_active = 0;
	CLT
	BLD  R2,4
;
;    //   ,      
;    main_exe = 0;
	BLD  R2,2
;
;    //    
;    dp = L_S_OFF;
	SET
	BLD  R2,3
;
;    //  OFF_
;    //    0
;    segment[ 0 ] = 0;
	LDI  R30,LOW(0)
	STS  _segment,R30
;    //      F
;    segment[ 1 ] = segment[ 2 ] = 20;
	LDI  R30,LOW(20)
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
;    //   
;    segment[ 3 ] = 99;
	LDI  R30,LOW(99)
	__PUTB1MN _segment,3
;
;    //     ""
;    delay_ms( 150 );
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
;
;    //    
;    while( !UTC_BUT || !H_BUT || !M_BUT );
_0x1FC:
	SBIS 0x16,5
	RJMP _0x1FF
	SBIS 0x16,3
	RJMP _0x1FF
	SBIC 0x16,4
	RJMP _0x1FE
_0x1FF:
	RJMP _0x1FC
_0x1FE:
;
;    //    
;    delay_ms( 1000 );
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
;    }
;
;
;}
_0x1F9:
	RET
; .FEND
;
;#include <Lib\start.c>
;//       
;void start( void ) {
; 0000 0021 void start( void ) {
_start:
; .FSTART _start
;
;//  
;unsigned char i = 0;
;
;    //        ,     first_start
;    //      99
;    if ( first_start != 99 ) {
	ST   -Y,R17
;	i -> R17
	LDI  R17,0
	LDI  R26,LOW(_first_start)
	LDI  R27,HIGH(_first_start)
	RCALL __EEPROMRDB
	CPI  R30,LOW(0x63)
	BREQ _0x201
;
;    //   
;    first_start = 99;
	LDI  R26,LOW(_first_start)
	LDI  R27,HIGH(_first_start)
	LDI  R30,LOW(99)
	RCALL __EEPROMWRB
;
;    //       +3 (  )
;    eeprom_utc = 3;
	LDI  R26,LOW(_eeprom_utc)
	LDI  R27,HIGH(_eeprom_utc)
	LDI  R30,LOW(3)
	RCALL __EEPROMWRB
;
;    //       12  
;    eeprom_alarm_h = 12;
	LDI  R26,LOW(_eeprom_alarm_h)
	LDI  R27,HIGH(_eeprom_alarm_h)
	LDI  R30,LOW(12)
	RCALL __EEPROMWRB
;
;    //       12  00 
;    eeprom_alarm_m = 0;
	LDI  R26,LOW(_eeprom_alarm_m)
	LDI  R27,HIGH(_eeprom_alarm_m)
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
;
;    //     (  )
;    eeprom_alarm = 1;
	LDI  R26,LOW(_eeprom_alarm)
	LDI  R27,HIGH(_eeprom_alarm)
	LDI  R30,LOW(1)
	RCALL __EEPROMWRB
;    }
;
;    //        
;    utc = eeprom_utc;
_0x201:
	LDI  R26,LOW(_eeprom_utc)
	LDI  R27,HIGH(_eeprom_utc)
	RCALL __EEPROMRDB
	MOV  R8,R30
;
;    //     
;    alarm_h = eeprom_alarm_h;
	LDI  R26,LOW(_eeprom_alarm_h)
	LDI  R27,HIGH(_eeprom_alarm_h)
	RCALL __EEPROMRDB
	STS  _alarm_h,R30
;
;    //     
;    alarm_m = eeprom_alarm_m;
	LDI  R26,LOW(_eeprom_alarm_m)
	LDI  R27,HIGH(_eeprom_alarm_m)
	RCALL __EEPROMRDB
	STS  _alarm_m,R30
;
;    //     
;    alarm = eeprom_alarm;
	LDI  R26,LOW(_eeprom_alarm)
	LDI  R27,HIGH(_eeprom_alarm)
	RCALL __EEPROMRDB
	RCALL __BSTB1
	BLD  R2,5
;
;    //   
;    sync_successfull = 0;
	CLR  R13
;
;    //    GPS     
;    gps_status = 0;
	CLT
	BLD  R2,0
;
;    // 
;    delay_ms( 1000 );
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
;
;    //       
;    printf( "START CLOCK\r\n" );
	__POINTW1FN _0x0,146
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
;
;/********************
;// !!!!!!!!!!!!!!!!!!!!!!!  !
;********************/
;//return;
;
;    //      ,       
;    while( 1 ) {
_0x202:
;
;
;            //           
;            // 1-   1,2
;            // 2-   3,4
;            // 3   
;            //    1/
;            if ( timer_1s ) {
	SBRS R2,1
	RJMP _0x205
;            //  
;            timer_1s = 0;
	CLT
	BLD  R2,1
;            //  
;            i++;
	SUBI R17,-1
;            //    
;            refresh_segment( i );
	MOV  R26,R17
	RCALL _refresh_segment
;            //    
;            if ( i >= 3 ) i = 0;
	CPI  R17,3
	BRLO _0x206
	LDI  R17,LOW(0)
;            }
_0x206:
;
;            //   ,     
;            if ( synchronization() ) return;
_0x205:
	RCALL _synchronization
	CPI  R30,0
	BREQ _0x207
	RJMP _0x20A0002
;    }
_0x207:
	RJMP _0x202
;}
; .FEND
;
;#include <Lib\button.c>
;//   
;
;//       
;void refresh_utc_led( void ) {
; 0000 0023 void refresh_utc_led( void ) {
_refresh_utc_led:
; .FSTART _refresh_utc_led
;
;    //     ,     
;    signed char tmp_utc = 0;
;
;    //  
;    tmp_utc = utc;
	ST   -Y,R17
;	tmp_utc -> R17
	LDI  R17,0
	MOV  R17,R8
;
;    //      utc,   
;    //    
;    if ( utc < 0 ) utc = -utc;
	LDI  R30,LOW(0)
	CP   R8,R30
	BRGE _0x208
	NEG  R8
;
;    //   U
;    segment[ 0 ] = 17;
_0x208:
	LDI  R30,LOW(17)
	STS  _segment,R30
;
;    //  ,    -  ,      
;    if ( tmp_utc < 0 ) segment[ 1 ] = 10; else segment[ 1 ] = 99;
	CPI  R17,0
	BRGE _0x209
	LDI  R30,LOW(10)
	RJMP _0x265
_0x209:
	LDI  R30,LOW(99)
_0x265:
	__PUTB1MN _segment,1
;
;    //  ,       ,  ,    10
;    if ( utc < 10 ) segment[ 2 ] = utc; else segment[ 2 ] = utc / 10;
	LDI  R30,LOW(10)
	CP   R8,R30
	BRGE _0x20B
	__PUTBMRN _segment,2,8
	RJMP _0x20C
_0x20B:
	MOV  R26,R8
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	__PUTB1MN _segment,2
;
;    //  ,   ,    ,    10
;    if ( utc < 10 ) segment[ 3 ] = 99; else segment[ 3 ] = utc % 10;
_0x20C:
	LDI  R30,LOW(10)
	CP   R8,R30
	BRGE _0x20D
	LDI  R30,LOW(99)
	RJMP _0x266
_0x20D:
	MOV  R26,R8
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
_0x266:
	__PUTB1MN _segment,3
;
;    //      
;    utc = tmp_utc;
	MOV  R8,R17
;}
	RJMP _0x20A0002
; .FEND
;
;//      
;void utc_but_press( void ) {
_utc_but_press:
; .FSTART _utc_but_press
;
;//  
;unsigned char auto_exit = 0;
;
;    //         
;    if ( !UTC_BUT ) {
	ST   -Y,R17
;	auto_exit -> R17
	LDI  R17,0
	SBIC 0x16,5
	RJMP _0x20F
;
;    //      ,   
;    if ( buzzer_active ) return;
	SBRC R2,4
	RJMP _0x20A0002
;
;    //   ,      
;    main_exe = 0;
	CLT
	BLD  R2,2
;
;    //    
;    dp = L_S_OFF;
	SET
	BLD  R2,3
;
;    //  U---
;    segment[ 0 ] = 17;
	LDI  R30,LOW(17)
	STS  _segment,R30
;    segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;
	LDI  R30,LOW(10)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
;
;    //     ""
;    delay_ms( 150 );
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
;
;    //    
;    while( !UTC_BUT );
_0x211:
	SBIS 0x16,5
	RJMP _0x211
;
;    //   
;    delay_ms( 250 );
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
;
;    //    
;    refresh_utc_led();
	RCALL _refresh_utc_led
;
;        //    
;        while( 1 ) {
_0x214:
;
;        //  
;        delay_ms( 50 );
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
;
;        //   
;        auto_exit++;
	SUBI R17,-1
;
;            //  
;            if ( !UTC_BUT ) {
	SBIC 0x16,5
	RJMP _0x217
;
;            //  
;            utc++;
	INC  R8
;
;            //   12-  ,    -12
;            if ( utc > 12 ) utc = -12;
	LDI  R30,LOW(12)
	CP   R30,R8
	BRGE _0x218
	LDI  R30,LOW(244)
	MOV  R8,R30
;
;            //    eeprom
;            eeprom_utc = utc;
_0x218:
	MOV  R30,R8
	LDI  R26,LOW(_eeprom_utc)
	LDI  R27,HIGH(_eeprom_utc)
	RCALL __EEPROMWRB
;
;            //    
;            refresh_utc_led();
	RCALL _refresh_utc_led
;
;            //   
;            auto_exit = 0;
	LDI  R17,LOW(0)
;
;            //    
;            while( !UTC_BUT );
_0x219:
	SBIS 0x16,5
	RJMP _0x219
;
;            //    
;            delay_ms( 200 );
	LDI  R26,LOW(200)
	LDI  R27,0
	RCALL _delay_ms
;            }
;
;        //  
;        if ( auto_exit > 100 ) return;
_0x217:
	CPI  R17,101
	BRLO _0x21C
	RJMP _0x20A0002
;        }
_0x21C:
	RJMP _0x214
;    }
;}
_0x20F:
	RJMP _0x20A0002
; .FEND
;
;//      
;void refresh_alarm_led( void ) {
_refresh_alarm_led:
; .FSTART _refresh_alarm_led
;
;    //   
;    if ( !alarm ) {
	SBRC R2,5
	RJMP _0x21D
;    //  
;    segment[ 0 ] = segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;
	LDI  R30,LOW(10)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
	STS  _segment,R30
;    // 
;    return;
	RET
;    }
;
;    //       (.. >10)    ,      
;    if ( ( alarm_h / 10 ) == 0 ) segment[ 0 ] = 99; else segment[ 0 ] = alarm_h / 10;
_0x21D:
	LDS  R26,_alarm_h
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	SBIW R30,0
	BRNE _0x21E
	LDI  R30,LOW(99)
	RJMP _0x267
_0x21E:
	LDS  R26,_alarm_h
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
_0x267:
	STS  _segment,R30
;
;    //   
;    segment[ 1 ] = alarm_h % 10;
	LDS  R26,_alarm_h
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	__PUTB1MN _segment,1
;
;    //   
;    segment[ 2 ] = alarm_m / 10;
	LDS  R26,_alarm_m
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	__PUTB1MN _segment,2
;
;    //   
;    segment[ 3 ] = alarm_m % 10;
	LDS  R26,_alarm_m
_0x20A0003:
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	__PUTB1MN _segment,3
;}
	RET
; .FEND
;
;//    
;void alarm_but_press( void ) {
_alarm_but_press:
; .FSTART _alarm_but_press
;
;//  
;unsigned char auto_exit = 0;
;
;    //          
;    if ( !H_BUT ) {
	ST   -Y,R17
;	auto_exit -> R17
	LDI  R17,0
	SBIC 0x16,3
	RJMP _0x220
;
;    //      ,   
;    if ( buzzer_active ) return;
	SBRC R2,4
	RJMP _0x20A0002
;
;    //   ,      
;    main_exe = 0;
	CLT
	BLD  R2,2
;
;    //    
;    dp = L_S_ON;
	BLD  R2,3
;
;    //  A-:--
;    segment[ 0 ] = 18;
	LDI  R30,LOW(18)
	STS  _segment,R30
;    segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;
	LDI  R30,LOW(10)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
;
;    //     ""
;    delay_ms( 150 );
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
;
;    //    
;    while( !H_BUT );
_0x222:
	SBIS 0x16,3
	RJMP _0x222
;
;    //   
;    delay_ms( 250 );
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
;
;    //    
;    refresh_alarm_led();
	RCALL _refresh_alarm_led
;
;        //    
;        while( 1 ) {
_0x225:
;
;        //    
;        delay_ms( 50 );
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
;
;        //   
;        auto_exit++;
	SUBI R17,-1
;
;///////////////////
;
;            //   UTC
;            //    UTC
;            if ( !UTC_BUT ) {
	SBIC 0x16,5
	RJMP _0x228
;            //        
;            alarm = ~alarm;
	LDI  R30,LOW(32)
	EOR  R2,R30
;
;            //    
;            eeprom_alarm = alarm;
	LDI  R30,0
	SBRC R2,5
	LDI  R30,1
	LDI  R26,LOW(_eeprom_alarm)
	LDI  R27,HIGH(_eeprom_alarm)
	RCALL __EEPROMWRB
;
;            //    
;            refresh_alarm_led();
	RCALL _refresh_alarm_led
;
;            //   
;            auto_exit = 0;
	LDI  R17,LOW(0)
;
;            //    
;            while( !UTC_BUT );
_0x229:
	SBIS 0x16,5
	RJMP _0x229
;
;            //    
;            delay_ms( 200 );
	LDI  R26,LOW(200)
	LDI  R27,0
	RCALL _delay_ms
;            }
;
;            //   
;            //        
;            if ( !H_BUT && alarm ) {
_0x228:
	SBIC 0x16,3
	RJMP _0x22D
	SBRC R2,5
	RJMP _0x22E
_0x22D:
	RJMP _0x22C
_0x22E:
;
;                //        
;                while( !H_BUT ) {
_0x22F:
	SBIC 0x16,3
	RJMP _0x231
;
;                //    +1
;                alarm_h++;
	LDS  R30,_alarm_h
	SUBI R30,-LOW(1)
	STS  _alarm_h,R30
;
;                //       
;                if ( alarm_h >= 24 ) alarm_h = 0;
	LDS  R26,_alarm_h
	CPI  R26,LOW(0x18)
	BRLO _0x232
	LDI  R30,LOW(0)
	STS  _alarm_h,R30
;
;                //    
;                eeprom_alarm_h = alarm_h;
_0x232:
	LDS  R30,_alarm_h
	LDI  R26,LOW(_eeprom_alarm_h)
	LDI  R27,HIGH(_eeprom_alarm_h)
	RCALL __EEPROMWRB
;
;                //   
;                auto_exit = 0;
	LDI  R17,LOW(0)
;
;                //    
;                refresh_alarm_led();
	RCALL _refresh_alarm_led
;
;                //  
;                delay_ms( 500 );
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
;                }
	RJMP _0x22F
_0x231:
;            }
;
;            //   
;            //        
;            if ( !M_BUT && alarm ) {
_0x22C:
	SBIC 0x16,4
	RJMP _0x234
	SBRC R2,5
	RJMP _0x235
_0x234:
	RJMP _0x233
_0x235:
;
;                //        
;                while( !M_BUT ) {
_0x236:
	SBIC 0x16,4
	RJMP _0x238
;
;                //    +1
;                alarm_m++;
	LDS  R30,_alarm_m
	SUBI R30,-LOW(1)
	STS  _alarm_m,R30
;
;                //       
;                if ( alarm_m >= 60 ) alarm_m = 0;
	LDS  R26,_alarm_m
	CPI  R26,LOW(0x3C)
	BRLO _0x239
	LDI  R30,LOW(0)
	STS  _alarm_m,R30
;
;                //    
;                eeprom_alarm_m = alarm_m;
_0x239:
	LDS  R30,_alarm_m
	LDI  R26,LOW(_eeprom_alarm_m)
	LDI  R27,HIGH(_eeprom_alarm_m)
	RCALL __EEPROMWRB
;
;                //   
;                auto_exit = 0;
	LDI  R17,LOW(0)
;
;                //    
;                refresh_alarm_led();
	RCALL _refresh_alarm_led
;
;                //  
;                delay_ms( 300 );
	LDI  R26,LOW(300)
	LDI  R27,HIGH(300)
	RCALL _delay_ms
;                }
	RJMP _0x236
_0x238:
;            }
;
;//////////////////
;
;        //   
;        if ( auto_exit > 100 ) return;
_0x233:
	CPI  R17,101
	BRSH _0x20A0002
;        }
	RJMP _0x225
;
;    }
;
;}
_0x220:
	RJMP _0x20A0002
; .FEND
;
;
;//    
;void stopwatch_but_press( void ) {
_stopwatch_but_press:
; .FSTART _stopwatch_but_press
;
;    //        
;    unsigned char i = 0;
;
;    //          
;    if ( !M_BUT ) {
	ST   -Y,R17
;	i -> R17
	LDI  R17,0
	SBIC 0x16,4
	RJMP _0x23B
;
;    //      ,   
;    if ( buzzer_active ) return;
	SBRC R2,4
	RJMP _0x20A0002
;
;    //   ,      
;    main_exe = 0;
	CLT
	BLD  R2,2
;
;    //    
;    dp = L_S_ON;
	BLD  R2,3
;
;    //  C-:--
;    segment[ 0 ] = 19;
	LDI  R30,LOW(19)
	STS  _segment,R30
;    segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;
	LDI  R30,LOW(10)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
;
;    //     ""
;    delay_ms( 150 );
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
;
;    //    
;    while( !M_BUT );
_0x23D:
	SBIS 0x16,4
	RJMP _0x23D
;
;        //     ,         
;        for ( i = 0; i < 4; i++ ) {
	LDI  R17,LOW(0)
_0x241:
	CPI  R17,4
	BRSH _0x242
;        //   
;        segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 99;
	LDI  R30,LOW(99)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
;        // -   _:__
;        delay_ms( 250 );
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
;        //   
;        segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 10;
	LDI  R30,LOW(10)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
;        // -  -:--
;        delay_ms( 250 );
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
;        }
	SUBI R17,-1
	RJMP _0x241
_0x242:
;
;        //   
;        stopwatch();
	RCALL _stopwatch
;    }
;
;}
_0x23B:
_0x20A0002:
	LD   R17,Y+
	RET
; .FEND
;
;// Declare your global variables here
;
;void main(void)
; 0000 0028 {
_main:
; .FSTART _main
; 0000 0029 // Declare your local variables here
; 0000 002A 
; 0000 002B // Input/Output Ports initialization
; 0000 002C // Port B initialization
; 0000 002D // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=Out Bit1=Out Bit0=Out
; 0000 002E DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
	LDI  R30,LOW(7)
	OUT  0x17,R30
; 0000 002F // State: Bit7=T Bit6=T Bit5=P Bit4=P Bit3=P Bit2=1 Bit1=0 Bit0=0
; 0000 0030 PORTB=(0<<PORTB7) | (0<<PORTB6) | (1<<PORTB5) | (1<<PORTB4) | (1<<PORTB3) | (1<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 0031 
; 0000 0032 // Port C initialization
; 0000 0033 // Function: Bit6=In Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out
; 0000 0034 DDRC=(0<<DDC6) | (1<<DDC5) | (1<<DDC4) | (1<<DDC3) | (1<<DDC2) | (1<<DDC1) | (1<<DDC0);
	LDI  R30,LOW(63)
	OUT  0x14,R30
; 0000 0035 // State: Bit6=T Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0
; 0000 0036 PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 0037 
; 0000 0038 // Port D initialization
; 0000 0039 // Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=In Bit0=In
; 0000 003A DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (1<<DDD3) | (1<<DDD2) | (0<<DDD1) | (0<<DDD0);
	LDI  R30,LOW(252)
	OUT  0x11,R30
; 0000 003B // State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=T Bit0=T
; 0000 003C PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 003D 
; 0000 003E // Timer/Counter 0 initialization
; 0000 003F // Clock source: System Clock
; 0000 0040 // Clock value: 15,625 kHz
; 0000 0041 TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 0042 TCNT0=0xBA;
	LDI  R30,LOW(186)
	OUT  0x32,R30
; 0000 0043 
; 0000 0044 // Timer/Counter 1 initialization
; 0000 0045 // Clock source: System Clock
; 0000 0046 // Clock value: 62,500 kHz
; 0000 0047 // Mode: Normal top=0xFFFF
; 0000 0048 // OC1A output: Disconnected
; 0000 0049 // OC1B output: Disconnected
; 0000 004A // Noise Canceler: Off
; 0000 004B // Input Capture on Falling Edge
; 0000 004C // Timer Period: 1 s
; 0000 004D // Timer1 Overflow Interrupt: On
; 0000 004E // Input Capture Interrupt: Off
; 0000 004F // Compare A Match Interrupt: Off
; 0000 0050 // Compare B Match Interrupt: Off
; 0000 0051 TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 0052 TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (0<<CS10);
	LDI  R30,LOW(4)
	OUT  0x2E,R30
; 0000 0053 TCNT1H=0x0B;
	LDI  R30,LOW(11)
	OUT  0x2D,R30
; 0000 0054 TCNT1L=0xDC;
	LDI  R30,LOW(220)
	OUT  0x2C,R30
; 0000 0055 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
; 0000 0056 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0057 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0058 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0059 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 005A OCR1BL=0x00;
	OUT  0x28,R30
; 0000 005B 
; 0000 005C // Timer/Counter 2 initialization
; 0000 005D // Clock source: System Clock
; 0000 005E // Clock value: 15,625 kHz
; 0000 005F // Mode: Normal top=0xFF
; 0000 0060 // OC2 output: Disconnected
; 0000 0061 // Timer Period: 9,984 ms
; 0000 0062 ASSR=0<<AS2;
	OUT  0x22,R30
; 0000 0063 TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (1<<CS22) | (1<<CS21) | (1<<CS20);
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 0064 TCNT2=0x64;
	LDI  R30,LOW(100)
	OUT  0x24,R30
; 0000 0065 OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 0066 
; 0000 0067 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0068 TIMSK=(0<<OCIE2) | (1<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (1<<TOIE1) | (1<<TOIE0);
	LDI  R30,LOW(69)
	OUT  0x39,R30
; 0000 0069 
; 0000 006A // External Interrupt(s) initialization
; 0000 006B // INT0: Off
; 0000 006C // INT1: Off
; 0000 006D MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 006E 
; 0000 006F // USART initialization
; 0000 0070 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0071 // USART Receiver: On
; 0000 0072 // USART Transmitter: On
; 0000 0073 // USART Mode: Asynchronous
; 0000 0074 // USART Baud Rate: 9600
; 0000 0075 UCSRA=(0<<RXC) | (0<<TXC) | (0<<UDRE) | (0<<FE) | (0<<DOR) | (0<<UPE) | (0<<U2X) | (0<<MPCM);
	OUT  0xB,R30
; 0000 0076 UCSRB=(1<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (1<<RXEN) | (1<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 0077 UCSRC=(1<<URSEL) | (0<<UMSEL) | (0<<UPM1) | (0<<UPM0) | (0<<USBS) | (1<<UCSZ1) | (1<<UCSZ0) | (0<<UCPOL);
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 0078 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 0079 UBRRL=0x67;
	LDI  R30,LOW(103)
	OUT  0x9,R30
; 0000 007A 
; 0000 007B // Analog Comparator initialization
; 0000 007C // Analog Comparator: Off
; 0000 007D // The Analog Comparator's positive input is
; 0000 007E // connected to the AIN0 pin
; 0000 007F // The Analog Comparator's negative input is
; 0000 0080 // connected to the AIN1 pin
; 0000 0081 ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0082 SFIOR=(0<<ACME);
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0083 
; 0000 0084 // ADC initialization
; 0000 0085 // ADC disabled
; 0000 0086 ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
	OUT  0x6,R30
; 0000 0087 
; 0000 0088 // SPI initialization
; 0000 0089 // SPI disabled
; 0000 008A SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
	OUT  0xD,R30
; 0000 008B 
; 0000 008C // TWI initialization
; 0000 008D // TWI disabled
; 0000 008E TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
	OUT  0x36,R30
; 0000 008F 
; 0000 0090 //    
; 0000 0091 S_1 = S_2 = S_3 = S_4 = L_BUS_OFF;
	CBI  0x15,0
	CBI  0x12,7
	CBI  0x12,6
	CBI  0x12,5
; 0000 0092 
; 0000 0093 //   
; 0000 0094 segment[ 0 ] = segment[ 1 ] = segment[ 2 ] = segment[ 3 ] = 99;
	LDI  R30,LOW(99)
	__PUTB1MN _segment,3
	__PUTB1MN _segment,2
	__PUTB1MN _segment,1
	STS  _segment,R30
; 0000 0095 
; 0000 0096 //     
; 0000 0097 BUZZER = BUZZER_ON;
	SBI  0x18,0
; 0000 0098 
; 0000 0099 //    0,5 .
; 0000 009A delay_ms( 500 );
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 009B 
; 0000 009C //  
; 0000 009D BUZZER = BUZZER_OFF;
	CBI  0x18,0
; 0000 009E 
; 0000 009F // Global enable interrupts
; 0000 00A0 #asm("sei")
	sei
; 0000 00A1 
; 0000 00A2 //        
; 0000 00A3 start();
	RCALL _start
; 0000 00A4 
; 0000 00A5         while (1) {
_0x24F:
; 0000 00A6 
; 0000 00A7         //   ,     
; 0000 00A8         main_exe = 1;
	SET
	BLD  R2,2
; 0000 00A9 
; 0000 00AA             //    1 /
; 0000 00AB             if ( timer_1s ) {
	SBRS R2,1
	RJMP _0x252
; 0000 00AC 
; 0000 00AD             //  
; 0000 00AE             timer_1s = 0;
	CLT
	BLD  R2,1
; 0000 00AF 
; 0000 00B0             //   
; 0000 00B1             calculation_time();
	RCALL _calculation_time
; 0000 00B2 
; 0000 00B3             //    
; 0000 00B4             refresh_led_time();
	RCALL _refresh_led_time
; 0000 00B5 
; 0000 00B6             //      ,   
; 0000 00B7             //    ,    
; 0000 00B8             if ( sync_gps >= PAUSE_SYNC ) synchronization(); else rx_clear();
	LDI  R30,LOW(3600)
	LDI  R31,HIGH(3600)
	CP   R10,R30
	CPC  R11,R31
	BRLO _0x253
	RCALL _synchronization
	RJMP _0x254
_0x253:
	RCALL _rx_clear
; 0000 00B9 
; 0000 00BA             //      UART
; 0000 00BB             //           
; 0000 00BC             printf( "CURRENT TIME: %i:%02d:%02d, TIME ZONE: ", now_h, now_m, now_s );
_0x254:
	__POINTW1FN _0x0,160
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R7
	RCALL __CBD1
	RCALL __PUTPARD1
	MOV  R30,R6
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOV  R30,R9
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _printf
	ADIW R28,14
; 0000 00BD 
; 0000 00BE             //     0,    "+"
; 0000 00BF             if ( utc > 0 ) printf( "+" );
	LDI  R30,LOW(0)
	CP   R30,R8
	BRGE _0x255
	__POINTW1FN _0x0,200
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
; 0000 00C0 
; 0000 00C1             //     
; 0000 00C2             printf( "%i, ", utc );
_0x255:
	__POINTW1FN _0x0,202
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R8
	RCALL __CBD1
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
; 0000 00C3 
; 0000 00C4             //   -     
; 0000 00C5             if ( alarm ) printf( "ALARM STATUS: %i:%02d", alarm_h, alarm_m );
	SBRS R2,5
	RJMP _0x256
	__POINTW1FN _0x0,207
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_alarm_h
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDS  R30,_alarm_m
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _printf
	ADIW R28,10
; 0000 00C6 
; 0000 00C7             //  ,     
; 0000 00C8             else printf( "ALARM STATUS: OFF" );
	RJMP _0x257
_0x256:
	__POINTW1FN _0x0,229
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
; 0000 00C9 
; 0000 00CA             //    ,     
; 0000 00CB             printf( "\r\n" );
_0x257:
	__POINTW1FN _0x0,92
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
; 0000 00CC             }
; 0000 00CD 
; 0000 00CE             //    UTC
; 0000 00CF             utc_but_press();
_0x252:
	RCALL _utc_but_press
; 0000 00D0 
; 0000 00D1             //     (   )
; 0000 00D2             alarm_but_press();
	RCALL _alarm_but_press
; 0000 00D3 
; 0000 00D4             //     (   )
; 0000 00D5             stopwatch_but_press();
	RCALL _stopwatch_but_press
; 0000 00D6 
; 0000 00D7             //  
; 0000 00D8             check_alarm();
	RCALL _check_alarm
; 0000 00D9         }
	RJMP _0x24F
; 0000 00DA }
_0x258:
	RJMP _0x258
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
; .FSTART _putchar
	ST   -Y,R26
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
_0x20A0001:
	ADIW R28,1
	RET
; .FEND
_put_usart_G100:
; .FSTART _put_usart_G100
	ST   -Y,R27
	ST   -Y,R26
	LDD  R26,Y+2
	RCALL _putchar
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	ADIW R28,3
	RET
; .FEND
__print_G100:
; .FSTART __print_G100
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RJMP _0x20000CC
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CD
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CD:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000CC:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
; .FEND
_printf:
; .FSTART _printf
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR2
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
	STD  Y+6,R30
	STD  Y+6+1,R30
	MOVW R26,R28
	ADIW R26,8
	RCALL __ADDW2R15
	RCALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_usart_G100)
	LDI  R31,HIGH(_put_usart_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,8
	RCALL __print_G100
	RCALL __LOADLOCR2
	ADIW R28,8
	POP  R15
	RET
; .FEND

	.CSEG
_strlen:
; .FSTART _strlen
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
; .FEND
_strlenf:
; .FSTART _strlenf
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
; .FEND
_strstrf:
; .FSTART _strstrf
	ST   -Y,R27
	ST   -Y,R26
    ldd  r26,y+2
    ldd  r27,y+3
    movw r24,r26
strstrf0:
    ld   r30,y
    ldd  r31,y+1
strstrf1:
	lpm  r0,z+
    tst  r0
    brne strstrf2
    movw r30,r24
    rjmp strstrf3
strstrf2:
    ld   r22,x+
    cp   r22,r0
    breq strstrf1
    adiw r24,1
    movw r26,r24
    tst  r22
    brne strstrf0
    clr  r30
    clr  r31
strstrf3:
	ADIW R28,4
	RET
; .FEND

	.CSEG
_atoi:
; .FSTART _atoi
	ST   -Y,R27
	ST   -Y,R26
   	ldd  r27,y+1
   	ld   r26,y
__atoi0:
   	ld   r30,x
        mov  r24,r26
	MOV  R26,R30
	RCALL _isspace
        mov  r26,r24
   	tst  r30
   	breq __atoi1
   	adiw r26,1
   	rjmp __atoi0
__atoi1:
   	clt
   	ld   r30,x
   	cpi  r30,'-'
   	brne __atoi2
   	set
   	rjmp __atoi3
__atoi2:
   	cpi  r30,'+'
   	brne __atoi4
__atoi3:
   	adiw r26,1
__atoi4:
   	clr  r22
   	clr  r23
__atoi5:
   	ld   r30,x
        mov  r24,r26
	MOV  R26,R30
	RCALL _isdigit
        mov  r26,r24
   	tst  r30
   	breq __atoi6
   	movw r30,r22
   	lsl  r22
   	rol  r23
   	lsl  r22
   	rol  r23
   	add  r22,r30
   	adc  r23,r31
   	lsl  r22
   	rol  r23
   	ld   r30,x+
   	clr  r31
   	subi r30,'0'
   	add  r22,r30
   	adc  r23,r31
   	rjmp __atoi5
__atoi6:
   	movw r30,r22
   	brtc __atoi7
   	com  r30
   	com  r31
   	adiw r30,1
__atoi7:
   	adiw r28,2
   	ret
; .FEND
_atol:
; .FSTART _atol
	ST   -Y,R27
	ST   -Y,R26
    ldd  r27,y+1
    ld   r26,y
__atol0:
    ld   r30,x
    push r26
	MOV  R26,R30
	RCALL _isspace
    pop  r26
    tst  r30
    breq __atol1
    adiw r26,1
    rjmp __atol0
__atol1:
    clt
    ld   r30,x
    cpi  r30,'-'
    brne __atol2
    set
    rjmp __atol3
__atol2:
    cpi  r30,'+'
    brne __atol4
__atol3:
    adiw r26,1
__atol4:
    clr  r0
    clr  r1
    clr  r24
    clr  r25
__atol5:
    ld   r30,x
    push r26
	MOV  R26,R30
	RCALL _isdigit
    pop  r26
    tst  r30
    breq __atol6
    movw r30,r0
    movw r22,r24
    rcall __atol8
    rcall __atol8
    add  r0,r30
    adc  r1,r31
    adc  r24,r22
    adc  r25,r23
    rcall __atol8
    ld   r30,x+
    clr  r31
    subi r30,'0'
    add  r0,r30
    adc  r1,r31
    adc  r24,r31
    adc  r25,r31
    rjmp __atol5
__atol6:
    movw r30,r0
    movw r22,r24
    brtc __atol7
    com  r30
    com  r31
    com  r22
    com  r23
    clr  r24
    adiw r30,1
    adc  r22,r24
    adc  r23,r24
__atol7:
    adiw r28,2
    ret

__atol8:
    lsl  r0
    rol  r1
    rol  r24
    rol  r25
    ret
; .FEND

	.DSEG

	.CSEG

	.CSEG
_isdigit:
; .FSTART _isdigit
	ST   -Y,R26
    ldi  r30,1
    ld   r31,y+
    cpi  r31,'0'
    brlo isdigit0
    cpi  r31,'9'+1
    brlo isdigit1
isdigit0:
    clr  r30
isdigit1:
    ret
; .FEND
_isspace:
; .FSTART _isspace
	ST   -Y,R26
    ldi  r30,1
    ld   r31,y+
    cpi  r31,' '
    breq isspace1
    cpi  r31,9
    brlo isspace0
    cpi  r31,13+1
    brlo isspace1
isspace0:
    clr  r30
isspace1:
    ret
; .FEND

	.CSEG

	.DSEG
_segment:
	.BYTE 0x4
_utc_counter:
	.BYTE 0x4
_stopwatch_counter:
	.BYTE 0x4
_buzzer_counter:
	.BYTE 0x1
_alarm_h:
	.BYTE 0x1
_alarm_m:
	.BYTE 0x1

	.ESEG
_first_start:
	.BYTE 0x1
_eeprom_utc:
	.BYTE 0x1
_eeprom_alarm_h:
	.BYTE 0x1
_eeprom_alarm_m:
	.BYTE 0x1
_eeprom_alarm:
	.BYTE 0x1

	.DSEG
_rx_buffer:
	.BYTE 0x100
_rx_wr_index:
	.BYTE 0x1
__seed_G102:
	.BYTE 0x4

	.CSEG

	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__BSTB1:
	CLT
	TST  R30
	BREQ PC+2
	SET
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
