// Timer 0 ( 4,48 ms )
//  
interrupt [TIM0_OVF] void timer0_ovf_isr(void) {

// Reinitialize Timer 0 value
TCNT0=0xBA;

//    
S_1 = S_2 = S_3 = S_4 = L_BUS_OFF; 

//   
D_P = L_S_OFF;

    switch ( step_led ) {                                                                                               

    //         1,    1 
    case 1: case_char( segment[ 0 ] ); S_1 = L_BUS_ON; break;                                          

    //         2,    2        
    case 2: case_char( segment[ 1 ] ); D_P = dp; S_2 = L_BUS_ON; break;                                       

    //         3,    3 
    case 3: case_char( segment[ 2 ] ); S_3 = L_BUS_ON; break;                       

    //         4,    4      
    case 4: case_char( segment[ 3 ] ); S_4 = L_BUS_ON; step_led = 0; break;                                                  

    //      0
    default: step_led = 0; break;                                                               
    }    

    //     
    step_led++;
}

// Timer1 ( 1 s )
interrupt [TIM1_OVF] void timer1_ovf_isr(void) {
// Reinitialize Timer1 value
TCNT1H=0xBDC >> 8;
TCNT1L=0xBDC & 0xff;

//     
utc_counter++;

//      
if ( utc_counter >= DAY ) utc_counter = 0;

//    
sync_gps++;

//    ,     
if ( sync_gps > PAUSE_SYNC ) sync_gps = PAUSE_SYNC; 

//    
stopwatch_counter++;

//     
if ( stopwatch_counter >= DAY ) stopwatch_counter = 0;

//    
timer_1s = 1;
}

// Timer2 ( 9,984 ms )
interrupt [TIM2_OVF] void timer2_ovf_isr(void) {
// Reinitialize Timer2 value
TCNT2=0x64;


//  !!!!
//     
//utc_counter++;
//      
//if ( utc_counter > DAY ) utc_counter = 0;


    //   GPS
    //    GPS        
    if ( !gps_status && GPS == GPS_ON ) {                                           
    //      
    gps_led_counter++; 

        //       7 ( .. 7 * 9,984 = 69,888  )
        if ( GPS_LED && gps_led_counter >= 7 ) { 
        //  
        GPS_LED = 0;
        //   
        gps_led_counter = 0; 
        }  
        
        //        93 ( .. 93 * 9,984 = 928,512  )  
        if ( !GPS_LED && gps_led_counter >= 93 ) { 
        //  
        GPS_LED = 1;         
        //  
        gps_led_counter = 0; 
        }   
    } 

    //    GPS        -   
    if ( gps_status && GPS == GPS_ON ) GPS_LED = 1; 
    
    //    -   
    if ( GPS == GPS_OFF ) GPS_LED = 0;
    
    //     
    if ( main_exe ) {
    //    
    dp_counter++;   

        //  ,      
        if ( dp_counter >= DP_SHOW) {                                 
        //     
        dp = ~dp;                                   
        //  
        dp_counter = 0;
        } 
    }
    
    //      1,     
    if ( buzzer_active ) {
    //                                                                   
    buzzer_counter++;          

        //         (    )
        if ( BUZZER && buzzer_counter >= 50 ) {           
        //     BUZZER_OFF
        BUZZER = BUZZER_OFF;                          
        //  
        buzzer_counter = 0;
        } 

        //         (     )
        if ( !BUZZER && buzzer_counter >= 100 ) {           
        //     BUZZER_ON
        BUZZER = BUZZER_ON;                          
        //  
        buzzer_counter = 0;
        } 
    } 
    //      0,      
    else {                                                                          
    //   
    BUZZER = BUZZER_OFF;          
    //    0
    buzzer_counter = 0;
    }                                          

}