#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)

// USART Receiver buffer
#define RX_BUFFER_SIZE 256

//  
unsigned char rx_buffer[ RX_BUFFER_SIZE ];

//    
unsigned char rx_wr_index = 0;

//    ""  
bit rx_buffer_complete = 0;

//    UART
void rx_clear( void ) {

	rx_wr_index = 0;
	rx_buffer_complete = 0;
	rx_buffer[ 0 ] = 0;    
    
//   
return;        
}

//      
unsigned char answer_contains( char flash * s ) {
	if ( strstrf( rx_buffer, s ) == 0 ) return 0;

//       0,    1,   
return 1;
}

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void) {
char status, data;
status = UCSRA;
data = UDR;

    //      
    //           
    if ( rx_buffer_complete ) return;
    
    if ( status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN) ) return;  
    
    //   0x0A,     0x0D
    if ( data == 0x0A ) return;      
   
    	//  0x0D -  
    	if ( data == 0x0D ) { 

        //    GPRMC-   , ..    
        if ( !answer_contains( "GPRMC" ) ) {

        //   
        rx_clear();           

        // 
        return;
        }   
        
    //  ,    
    rx_buffer_complete = 1;             
        
    //   
    return;                    
	} 
    //    
    else {   

	//   
	rx_buffer[ rx_wr_index ] = data;

	//   0   
	rx_buffer[ rx_wr_index + 1 ] = 0;

	//     
	rx_wr_index++;

	//  
	if ( rx_wr_index > ( RX_BUFFER_SIZE - 2 ) ) rx_wr_index = RX_BUFFER_SIZE - 2; 
        
    // 
    return;
	}             
    
}
